/**************************************************************** 
 * Description: 三连击
 枚举a的可能值：
a从123开始枚举，直到a * 3仍然是三位数为止。
检查数字是否唯一使用：
使用n[10]数组记录数字1到9是否已经被使用。
分别对a，b = a * 2，和c = a * 3进行分解，将每个数字的百位、十位和个位对应位置标记为1。
验证并输出结果：
如果所有数字1到9都恰好使用了一次，即n[1]到n[9]都为1，则输出这三个三位数a，b，c。
该程序最终会输出所有满足1:2:3比例且由1到9组成的三位数组合。
 * Author: Alex Li
 * Date: 2024-08-22 20:11:22
 * LastEditTime: 2024-08-22 20:13:59
****************************************************************/
#include<iostream>
using namespace std;

int main() {
    int a, b, c, s, h;
    int n[10]; // 数组n用于标记1到9这9个数字是否被使用，n[x] = 1表示数字x已被使用，n[x] = 0表示数字x未被使用

    // 枚举a的所有可能值，a是三个数中最小的那个三位数
    for (a = 123; a * 3 < 988; a++) { // a从123开始，确保a*3不会超过三位数的范围，即不超过987
        // 初始化标记数组n
        for (h = 1; h < 10; h++) {
            n[h] = 0; // 将数组n所有位置清零，表示所有数字都还未被使用
        }
        
        // 标记a中各个数字
        n[a / 100] = 1;       // 百位数字标记为已使用
        n[a / 10 % 10] = 1;   // 十位数字标记为已使用
        n[a % 10] = 1;        // 个位数字标记为已使用

        b = a * 2; // b是a的两倍
        // 标记b中各个数字
        n[b / 100] = 1;       // 百位数字标记为已使用
        n[b / 10 % 10] = 1;   // 十位数字标记为已使用
        n[b % 10] = 1;        // 个位数字标记为已使用

        c = a * 3; // c是a的三倍
        // 标记c中各个数字
        n[c / 100] = 1;       // 百位数字标记为已使用
        n[c / 10 % 10] = 1;   // 十位数字标记为已使用
        n[c % 10] = 1;        // 个位数字标记为已使用

        // 检查是否所有数字1到9都恰好使用了一次
        for (s = 0, h = 1; h < 10; h++) {
            s += n[h]; // 统计被标记的数字个数
        }

        // 如果所有数字1到9都被使用（即s == 9），则输出结果
        if (s == 9) {
            cout << a << ' ' << b << ' ' << c << endl; // 输出满足条件的三个三位数
        }
    }

    return 0;
}
